package rewindfp {
	import flash.utils.Dictionary;
	
	public class Frame {
		
		public var keys:Vector.<String>;
		public var values:Dictionary;
		public var unique:Dictionary;
		public var iterations:int;
		
		public function Frame() {
			values = new Dictionary;
			unique = new Dictionary;
			keys = new Vector.<String>;
			iterations = 1;
		}
		
		public function renew():void {
			for (var key: String in keys) {
				delete values[key];
				delete unique[key];
			}
			keys.length = 0;
			iterations = 1;
		}
		
		public function getValue(str:String):Object {
			return values[str];
		}
		
		public function addValue(str:String, val:Object, u:Boolean = false):void {
			values[str] = val;
			unique[str] = u;
			keys.push(str);
		}
		
		public function equals(frame: Frame): Boolean {
			if (keys.length != frame.keys.length || keys.toString() != frame.keys.toString()) {
				return false;
			}
			for each(var key: String in keys) {
				if (unique[key]) {
					continue;
				}
				if (values[key] != frame.values[key]) {
					return false;
				}
			}
			return true;
		}
	
	}

}