package rewindfp {
	import flash.utils.Dictionary;
	import net.flashpunk.FP;
	
	public class FrameManager {
		
		public var PLAYRATE:Number = 0.05;
		public var REWINDRATE:Number = 0.00001;
		
		public var frames:Vector.<Frame>;
		public var framePool:Vector.<Frame>;
		public var rewindables:Vector.<Rewindable>;
		
		public var playTimer:Number = 0;
		public var rewindTimer:Number = 0;
		
		public function FrameManager() {
			frames = new Vector.<Frame>;
			framePool = new Vector.<Frame>;
			rewindables = new Vector.<Rewindable>;
		}
		
		public function add(r:Rewindable):void {
			rewindables.push(r);
		}
		
		public function getValue(key:String):Object {
			if (frames.length == 0)
				return null;
			return frames[frames.length - 1].getValue(key);
		}
		
		public function forward(delta:Number):void {
			playTimer += delta;
			if (playTimer >= PLAYRATE) {
				playTimer -= PLAYRATE;
				var cFrame:Frame;
				if (framePool.length > 0) {
					cFrame = framePool.pop();
				} else {
					cFrame = new Frame();
				}
				for each (var r:Rewindable in rewindables) {
					var map:Object = r.record();
					for (var key:String in map) {
						cFrame.addValue(key, map[key]);
					}
				}
				if (frames.length == 0 || !frames[frames.length - 1].equals(cFrame)) {
					frames.push(cFrame);
				} else {
					frames[frames.length - 1].iterations += 1;
					cFrame.renew();
					framePool.push(cFrame);
				}
			}
		}
		
		public function rewind(delta:Number):void {
			rewindTimer += delta;
			if (frames.length > 0) {
				rewindTimer += delta;
				if (rewindTimer >= REWINDRATE) {
					rewindTimer -= REWINDRATE;
					var latest:Frame = frames[frames.length - 1];
					if (latest.iterations > 1) {
						latest.iterations -= 1;
					} else {
						var f:Frame = frames.pop();
						f.renew();
						framePool.push(f);
					}
				}
			}
		}
	
	}

}